<!-- ...................................................................... -->
<!-- UML Class Model V1.0 ................................................. -->
<!-- File class.mod ....................................................... -->

<!-- Copyright(c) 1998 Normand Rivard.

     Permission to use, copy, modify and distribute the UML-Xchange DTD and
     its accompanying documentation for any purpose and without fee is
     hereby granted in perpetuity, provided that the above copyright
     notice and this paragraph appear in all copies.  The copyright
     holders make no representation about the suitability of the DTD for
     any purpose.  It is provided "as is" without expressed or implied
     warranty.

     If you modify the UML-Xchange DTD in any way, except for declaring and
     referencing additional sets of general entities and declaring
     additional notations, label your DTD as a variant of UML-Xchange.  See
     the maintenance documentation for more information.

     Please direct all questions, bug reports, or suggestions for
     changes to one of the maintainers:

     o Normand Rivard
       <nrivard@cam.org>

-->

<!ENTITY % class.content    "(package | class | interface | assoc |
generalization)">

<!ELEMENT class.mod     - - (%ident;, class.set, class.diagram*)>

<!ELEMENT class.set     - - (%ident;, (%class.content;)+)>

<!ELEMENT package       - - (%ident;, (%class.content;)*)>

<!ATTLIST package           keyword ( subsystem
                                    | model
                                    | system
                                    | facade
                                    | framework
                                    | toppackage
                                    | userdefined ) #IMPLIED
                            usrkeyw         CDATA   #IMPLIED
                            dependencies    IDREFS  #IMPLIED
                            %idreq.common.attrib;>

<!ELEMENT class         - - (%ident;, name,
                            operation*,
                            attribute*,
                            constraint*)>

<!ATTLIST class             abstract        %yesorno.attvals; %yes.attval;
                            dependencies    IDREFS  #IMPLIED
                            stereotype      CDATA   #IMPLIED
                            parameterized   IDREFS  #IMPLIED
                            refines         IDREF   #IMPLIED
                            association     IDREF   #IMPLIED
                            %idreq.common.attrib;>

<!ELEMENT interface     - - (%ident;, name, operation*, constraint*)>

<!ATTLIST interface         dependencies    IDREFS  #IMPLIED
                            stereotype      CDATA   #IMPLIED
                            %idreq.common.attrib;>

<!ELEMENT operation     - - (%ident;, name, parameter*, property?)>

<!ATTLIST operation         type    CDATA   #IMPLIED
                            %visib;
                            %idreq.common.attrib;>

<!ELEMENT property      - - (#PCDATA)>

<!ATTLIST property          %id.common.attrib;>

<!ELEMENT attribute     - - (%ident;, name)>

<!ATTLIST attribute         type            CDATA   #IMPLIED
                            initial.value   CDATA   #IMPLIED
                            derived         %yesorno.attvals; %no.attval;
                            %visib;
                            %idreq.common.attrib;>

<!ELEMENT assoc         - - (%ident;, name?, assoc.from, assoc.to,
constraint*)>

<!ATTLIST assoc             assoc.type      (simple | aggregate |
composite) "simple"
                            derived         %yesorno.attvals; %no.attval;
                            stereotype      CDATA   #IMPLIED
                            qualified.by    IDREF   #IMPLIED
                            %idreq.common.attrib;>

<!ELEMENT assoc.from    - o EMPTY>

<!ELEMENT assoc.to      - o EMPTY>

<!ENTITY %  assoc.content   "my.class       IDREF   #REQUIRED
                            multiplicity    CDATA   #IMPLIED
                            ordered         %yesorno.attvals; %no.attval;
                            navigable       %yesorno.attvals; %no.attval;
                            %id.common.attrib;">

<!ATTLIST assoc.from        %assoc.content;>

<!ATTLIST assoc.to          %assoc.content;>

<!ELEMENT generalization - - (constraint*)>

<!ATTLIST generalization        super           IDREF   #REQUIRED
                                sub             IDREFS  #REQUIRED
                                discriminator   IDREF   #IMPLIED
                                discr.complete  %yesorno.attvals; %no.attval;
                                dynamic         %yesorno.attvals; %no.attval;
                                %id.common.attrib;>

<!-- Class diagram components.............................................. -->
<!-- ...................................................................... -->

<!ELEMENT class.diagram - - (%ident;, name?, (note
                                            | package.comp
                                            | class.comp
                                            | assoc.comp
                                            | gener.comp
                                            | dep.comp
                                            )*)>

<!ATTLIST class.diagram     %rect;
                            %id.common.attrib;>

<!ELEMENT package.comp  - o EMPTY>

<!ATTLIST package.comp      from.set    IDREF   #REQUIRED
                            %rect;
                            %id.common.attrib;>

<!ELEMENT class.comp    - - (constraint.comp*)>

<!ATTLIST class.comp        from.set    IDREF   #REQUIRED
                            op.visible  %yesorno.attvals; #IMPLIED
                            att.visible %yesorno.attvals; #IMPLIED
                            ste.visible %yesorno.attvals; #IMPLIED
                            %rect;
                            %id.common.attrib;>

<!ELEMENT constraint.comp   - o EMPTY>

<!ATTLIST constraint.comp   from.set    IDREF   #REQUIRED
                            %rect;>

<!ELEMENT assoc.comp    - - (point, point+)>

<!ATTLIST assoc.comp        from.set    IDREF   #REQUIRED
                            mult.visible    %yesorno.attvals; #IMPLIED
                            %id.common.attrib;>

<!ELEMENT gener.comp    - - (link*)>

<!ATTLIST gener.comp        from.set    IDREF   #REQUIRED
                            %id.common.attrib;>

<!ELEMENT dep.comp      - - (point, point+)>

<!ATTLIST dep.comp          from1       IDREF   #REQUIRED
                            from2       IDREF   #REQUIRED
                            mult.visible    %yesorno.attvals; #IMPLIED
                            %id.common.attrib;>

<!-- End of Class model DTD V1.0 .......................................... -->
<!-- ...................................................................... -->
